package com.woniuxy.i_factorymethod.a;

// Ϊ˽򵥹ȱ㣬ع룺

interface Food {
	public void eat();
}

class Hamburger implements Food {
	@Override
	public void eat() {
		System.out.println("");
	}
}
class FrenchFries implements Food {
	@Override
	public void eat() {
		System.out.println("䷬ѽŶ");
	}
}

interface FoodFactory {
	Food getFood();
}

class HamburgerFactory implements FoodFactory {
	@Override
	public Food getFood() {
		return new Hamburger();
	}
}
class FrenchFriesFactory implements FoodFactory {
	@Override
	public Food getFood() {
		return new FrenchFries();
	}
}

class Business {
	// Ʒ
	public void taste(FoodFactory factory) {
		Food f = factory.getFood();
		System.out.println("ίһ");
		f.eat();
		System.out.println("Ψһ");
		
		
		System.out.println("ί");
		f.eat();
		System.out.println("Ψ");
		
		
		System.out.println("ί");
		f.eat();
		System.out.println("Ψ");
	}
}

//===========================================================

class MexicoChicken implements Food {
	@Override
	public void eat() {
		System.out.println("ī缦");
	}
}

class MexicoChickenFactory implements FoodFactory {

	@Override
	public Food getFood() {
		return new MexicoChicken();
	}
	
}


public class Test {

	public static void main(String[] args) {
		FoodFactory ff = new FrenchFriesFactory();
		FoodFactory ff2 = new MexicoChickenFactory();
		
		Business b = new Business();
		
		b.taste(ff);
		b.taste(ff2);
		
		
	}

}

// ɻ
// 1. Ȼͻ˳ԱѾչ²Ʒˣ²ƷǿͻԼģͻ˳ԱͿֱʹԼ²Ʒ࣬öǸӦĹ
// 2. ΪʲôǻҪࡱȥӶӦĹأ
// 3. ôǸBusinesstasteֱӽFoodɣͲҪ.

// ðɣҲȱ㣺
// 1. ˸Ӷ
// 2. жֲͬ͵ĲƷʱƷȼ 磬ڼ  ر

// 3. ɴ˾ˣ󹤳ģʽ »طֽ

